
package com.madhu.xml;

import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.*;

public class SAXEntity extends DefaultHandler {
	public SAXEntity() {
	}

	public void startDocument() {
		System.out.println("***Start of Document***");
	}

	public void endDocument() {
		System.out.println("***End of Document***");
	}

	public void startElement(String uri, String localName,
		String qName, Attributes attributes) {

		System.out.print("<" + qName);
		int n = attributes.getLength();
		for (int i=0; i<n; i+=1) {
			System.out.print(" " + attributes.getQName(i) +
				"='" + attributes.getValue(i) + "'");
		}
		System.out.println(">");
	}

	public void characters(char[] ch, int start, int length) {
		System.out.println(new String(ch, start, length).trim());
	}

	public void endElement(String namespaceURI, String localName,
		String qName) throws SAXException {

		System.out.println("</" + qName + ">");
	}

	public InputSource resolveEntity(String publicId, String systemId) {
		try {
			if (systemId.equals("http://www.madhu.com/xml/hardcover.txt")) {
				return new InputSource(
					new FileReader("hardcover.txt"));
			}
		} catch (IOException e) {
		}
		return null; // for default behavior
	}

	public static void main(String args[]) throws Exception {
		if (args.length != 1) {
			System.err.println("Usage: java SAXEntity <xml-file>");
			System.exit(1);
		}

		XMLReader parser = XMLReaderFactory.createXMLReader(
			"org.apache.xerces.parsers.SAXParser");

		parser.setFeature("http://xml.org/sax/features/validation", true);

		SAXEntity handler = new SAXEntity();
		parser.setContentHandler(handler);
		parser.setEntityResolver(handler);

		parser.parse(new InputSource(new FileReader(args[0])));
	}
}
