
package com.madhu.spider;

import java.io.*;
import java.util.*;

import org.xml.sax.*;
import hplb.xml.Tokenizer;

public class StateHandler extends HandlerBase {
	public static final int MAX_COLUMNS = 3;

	private HashMap linkMap;
	private ArrayList dataList;

	private String actionURL;
	private String countyParamName;
	private String countyPage;
	private String optionText;
	private String url;

	private boolean grabOptionText;
	private boolean grabTable;
	private String[] row;
	private int columnIndex;

	public StateHandler() {
		linkMap = new HashMap(75);
		dataList = new ArrayList(100);
		grabOptionText = false;
		row = new String[MAX_COLUMNS];
		columnIndex = -1;
		grabTable = false;
	}

	public void startElement(String name, AttributeMap atts) {
		if (name.equalsIgnoreCase("form")) {
			actionURL = atts.getValue("ACTION");
			return;
		}
		if (name.equalsIgnoreCase("SELECT")) {
			countyParamName = atts.getValue("NAME");
			url = actionURL + "?" + countyParamName + "=";
			return;
		}
		if (name.equalsIgnoreCase("OPTION")) {
			countyPage = atts.getValue("value");
			if (countyPage == null) {
				countyPage = atts.getValue("VALUE");
			}
			grabOptionText = true;
			return;
		}
		if (grabTable && name.equalsIgnoreCase("TR")) {
			columnIndex = 0;
		}
	}

	public void characters(char ch[], int start, int length)
		throws Exception {

		String text = new String(ch, start, length);
		text = text.replace('\n', ' ');
		text = text.replace('\r', ' ');
		text = text.trim();
		if (text.length() == 0) {
			return;
		}
		if (grabOptionText) {
			grabOptionText = false;
			optionText = text;
			linkMap.put(optionText, countyPage);
		}
		if (text.equals("People QuickFacts") ||
			text.equals("Business QuickFacts") ||
			text.equals("Geography QuickFacts")) {

			grabTable = true;
		}
		if (columnIndex >= 0 && columnIndex < MAX_COLUMNS) {
			row[columnIndex++] = text;
		}
		if (columnIndex == MAX_COLUMNS) {
			columnIndex = -1;
			dataList.add(row);
			row = new String[MAX_COLUMNS];
		}
	}

	public void endElement(String name) {
		grabOptionText = false;
		if (name.equalsIgnoreCase("table")) {
			grabTable = false;
		}
	}

	public void warning(String message, String systemID,
		int line, int column) throws Exception {
			// ignore errors
	}

	public Iterator getCountyNames() {
		return linkMap.keySet().iterator();
	}

	public String getCountyURI(String state) {
		String htmlPage = (String) linkMap.get(state);
		if (htmlPage == null) {
			return null;
		}
		return url + htmlPage;
	}

	public ArrayList getDataList() {
		return dataList;
	}
}
