
package com.madhu.spider;

import java.io.*;
import java.util.*;

import org.xml.sax.*;
import hplb.xml.Tokenizer;

public class USAHandler extends HandlerBase {
	private HashMap linkMap;
	private String actionURL;
	private String stateParamName;
	private boolean grabText;
	private String statePage;
	private String optionText;
	private String url;

	public USAHandler() {
		linkMap = new HashMap(75);
		grabText = false;
	}

	public void startElement(String name, AttributeMap atts) {
		if (name.equalsIgnoreCase("form")) {
			actionURL = atts.getValue("ACTION");
			return;
		}
		if (name.equalsIgnoreCase("SELECT")) {
			stateParamName = atts.getValue("NAME");
			url = actionURL + "?" + stateParamName + "=";
			return;
		}
		if (name.equalsIgnoreCase("OPTION")) {
			statePage = atts.getValue("value");
			if (statePage == null) {
				statePage = atts.getValue("VALUE");
			}
			grabText = true;
			return;
		}
	}

	public void characters(char ch[], int start, int length)
		throws Exception {

		if (grabText) {
			String text = new String(ch, start, length);
			text = text.replace('\n', ' ');
			text = text.replace('\r', ' ');
			optionText = text.trim();
			linkMap.put(optionText, statePage);
		}
	}

	public void endElement(String name) {
		grabText = false;
	}

	public void warning(String message, String systemID,
		int line, int column) throws Exception {
			// ignore errors
	}

	public Iterator getStateNames() {
		return linkMap.keySet().iterator();
	}

	public String getStateURI(String state) {
		String htmlPage = (String) linkMap.get(state);
		if (htmlPage == null) {
			return null;
		}
		return url + htmlPage;
	}
}
